## libzeem 2.1.2+dfsg

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause
# 
# Copyright (c) 2026 Maarten L. Hekkelman
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.23)

project(zeem VERSION 2.1.2 LANGUAGES CXX)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(CMakePackageConfigHelpers)
include(CPM)
include(CTest)
include(CheckCXXSourceCompiles)
include(VersionString)

option(ZEEM_BUILD_DOCUMENTATION "Build documentation" OFF)
option(ZEEM_BUILD_EXAMPLES "Build example executables" ON)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
elseif(MSVC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
endif()

try_compile(STD_CHARCONV_COMPILING
	SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/cmake/test-charconv.cpp)

if(NOT STD_CHARCONV_COMPILING)
	message(NOTICE "zeem: Using fast_float for std::from_chars")
	CPMFindPackage(
		NAME fast_float
		GIT_REPOSITORY "https://github.com/fastfloat/fast_float"
		GIT_TAG v8.0.2
		EXCLUDE_FROM_ALL YES)
endif()

try_run(TEST_STD_CHRONO_FROM_STREAM_R TEST_STD_CHRONO_FROM_STREAM_C
	SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/cmake/test-chrono_from_stream.cpp
	CXX_STANDARD 20)

if ("${TEST_STD_CHRONO_FROM_STREAM_R}" EQUAL "0")
	set(USE_STD_CHRONO_FROM_STREAM TRUE)
else()
	set(USE_STD_CHRONO_FROM_STREAM FALSE)
endif()

if(NOT USE_STD_CHRONO_FROM_STREAM)
	message(NOTICE "zeem: Using Howard Hinnants date for from_stream")
	CPMFindPackage(
		NAME date
		GIT_REPOSITORY "https://github.com/HowardHinnant/date"
		VERSION 3.0.3
		EXCLUDE_FROM_ALL YES
		OPTIONS
		"USE_SYSTEM_TZ_DB ON"
		"BUILD_TZ_LIB ON")
	set(ZEEM_USE_DATE_H ON)
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/include/zeem/config.hpp.in
	${CMAKE_CURRENT_SOURCE_DIR}/include/zeem/config.hpp @ONLY)

# Version info
write_version_header("${CMAKE_CURRENT_SOURCE_DIR}/src" LIB_NAME "libzeem")

file(GLOB zeem_src src/*.cpp)
file(GLOB_RECURSE zeem_hdr include/*.hpp)

if(STD_CHARCONV_COMPILING)
	list(FILTER zeem_src EXCLUDE REGEX src/charconv-fast_float.cpp)
endif()

add_library(zeem ${zeem_src})
add_library(zeem::zeem ALIAS zeem)

target_sources(zeem
	PUBLIC
	FILE_SET zeem_headers TYPE HEADERS
	BASE_DIRS
	${CMAKE_CURRENT_SOURCE_DIR}/include
	FILES
	${zeem_hdr})

target_compile_features(zeem PUBLIC cxx_std_20)

if(NOT STD_CHARCONV_COMPILING)
	target_include_directories(zeem PRIVATE $<TARGET_PROPERTY:FastFloat::fast_float,INTERFACE_INCLUDE_DIRECTORIES>)
endif()

if(NOT USE_STD_CHRONO_FROM_STREAM)
	target_link_libraries(zeem PUBLIC date::date-tz)
	set(FIND_DEPENDENCIES "find_dependency(date REQUIRED)")
endif()

set(zeem_MAJOR_VERSION ${PROJECT_VERSION_MAJOR})
set_target_properties(zeem PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${PROJECT_VERSION_MAJOR}
	INTERFACE_zeem_MAJOR_VERSION ${PROJECT_VERSION_MAJOR}
	COMPATIBLE_INTERFACE_STRING zeem_MAJOR_VERSION)

install(TARGETS zeem
	EXPORT zeem-targets
	FILE_SET zeem_headers DESTINATION include)

install(EXPORT zeem-targets
	NAMESPACE zeem::
	DESTINATION lib/cmake/zeem)

configure_package_config_file(
	${PROJECT_SOURCE_DIR}/cmake/zeem-config.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/zeem-config.cmake
	INSTALL_DESTINATION lib/cmake/zeem)

write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/zeem-config-version.cmake"
	COMPATIBILITY AnyNewerVersion)

install(FILES
	${CMAKE_CURRENT_BINARY_DIR}/zeem-config.cmake
	${CMAKE_CURRENT_BINARY_DIR}/zeem-config-version.cmake
	DESTINATION lib/cmake/zeem)

if(BUILD_TESTING AND PROJECT_IS_TOP_LEVEL)
	add_subdirectory(test)
endif()

if(ZEEM_BUILD_EXAMPLES)
	add_subdirectory(examples)
endif()

if(ZEEM_BUILD_DOCUMENTATION)
	add_subdirectory(docs)
endif()

=== docs/CMakeLists.txt ===
find_package(Doxygen REQUIRED)
find_package(Sphinx REQUIRED)

# Find all the public headers
# get_target_property(ZEEM_PUBLIC_HEADER_DIR zeem INTERFACE_INCLUDE_DIRECTORIES)
set(ZEEM_PUBLIC_HEADER_DIR ${PROJECT_SOURCE_DIR}/include)
file(GLOB_RECURSE ZEEM_PUBLIC_HEADERS ${ZEEM_PUBLIC_HEADER_DIR}/zeem/*.hpp)

set(DOXYGEN_INPUT_DIR ${ZEEM_PUBLIC_HEADER_DIR}/zeem/)
set(DOXYGEN_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/xml)
set(DOXYGEN_INDEX_FILE ${DOXYGEN_OUTPUT_DIR}/index.xml)
set(DOXYFILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
set(DOXYFILE_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

# Replace variables inside @@ with the current values
configure_file(${DOXYFILE_IN} ${DOXYFILE_OUT} @ONLY)

add_custom_command(
	OUTPUT ${DOXYGEN_OUTPUT_DIR}
	COMMAND ${CMAKE_COMMAND} -E make_directory ${DOXYGEN_OUTPUT_DIR})

add_custom_command(OUTPUT ${DOXYGEN_INDEX_FILE}
	DEPENDS ${ZEEM_PUBLIC_HEADERS} ${DOXYGEN_OUTPUT_DIR} ${DOXYFILE_OUT}
	COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE_OUT}
	MAIN_DEPENDENCY ${DOXYFILE_OUT} ${DOXYFILE_IN}
	COMMENT "Generating docs")

add_custom_target(Doxygen-zeem ALL DEPENDS ${DOXYGEN_INDEX_FILE})
set_property(TARGET Doxygen-zeem APPEND PROPERTY ADDITIONAL_CLEAN_FILES ${DOXYGEN_OUTPUT_DIR})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in ${CMAKE_CURRENT_SOURCE_DIR}/conf.py @ONLY)

set(SPHINX_SOURCE ${CMAKE_CURRENT_SOURCE_DIR})
set(SPHINX_BUILD ${CMAKE_CURRENT_BINARY_DIR}/sphinx)

add_custom_target(Sphinx-zeem ALL
	COMMAND ${SPHINX_EXECUTABLE} -b html
	-Dbreathe_projects.zeem=${DOXYGEN_OUTPUT_DIR}
	${SPHINX_SOURCE} ${SPHINX_BUILD}
	DEPENDS ${DOXYGEN_INDEX_FILE}
	BYPRODUCTS ${CMAKE_CURRENT_SOURCE_DIR}/api
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating documentation with Sphinx")

set_property(TARGET Sphinx-zeem APPEND PROPERTY ADDITIONAL_CLEAN_FILES ${CMAKE_CURRENT_SOURCE_DIR}/api)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/sphinx/ DESTINATION share/doc/zeem PATTERN .doctrees EXCLUDE)

=== docs/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.10
# by the following command:
#
#    pip-compile --output-file=requirements.txt requirements.in
#
alabaster==0.7.13
    # via sphinx
babel==2.12.1
    # via sphinx
beautifulsoup4==4.12.2
    # via exhale
breathe==4.35.0
    # via
    #   -r requirements.in
    #   exhale
certifi==2024.7.4
    # via requests
charset-normalizer==3.2.0
    # via requests
docutils==0.17.1
    # via
    #   breathe
    #   exhale
    #   myst-parser
    #   sphinx
    #   sphinx-rtd-theme
exhale==0.3.6
    # via -r requirements.in
idna==3.7
    # via requests
imagesize==1.4.1
    # via sphinx
jinja2==3.1.6
    # via
    #   myst-parser
    #   sphinx
lxml==4.9.3
    # via exhale
markdown-it-py==2.2.0
    # via
    #   mdit-py-plugins
    #   myst-parser
markupsafe==2.1.3
    # via jinja2
mdit-py-plugins==0.3.5
    # via myst-parser
mdurl==0.1.2
    # via markdown-it-py
myst-parser==0.18.1
    # via -r requirements.in
packaging==23.1
    # via sphinx
pygments==2.16.1
    # via sphinx
pyyaml==6.0.1
    # via myst-parser
requests==2.32.4
    # via sphinx
six==1.16.0
    # via exhale
snowballstemmer==2.2.0
    # via sphinx
soupsieve==2.4.1
    # via beautifulsoup4
sphinx==4.5.0
    # via
    #   -r requirements.in
    #   breathe
    #   exhale
    #   myst-parser
    #   sphinx-rtd-theme
    #   sphinxcontrib-jquery
sphinx-rtd-theme==1.3.0
    # via -r requirements.in
sphinxcontrib-applehelp==1.0.4
    # via sphinx
sphinxcontrib-devhelp==1.0.2
    # via sphinx
sphinxcontrib-htmlhelp==2.0.1
    # via sphinx
sphinxcontrib-jquery==4.1
    # via sphinx-rtd-theme
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.3
    # via sphinx
sphinxcontrib-serializinghtml==1.1.5
    # via sphinx
typing-extensions==4.7.1
    # via myst-parser
urllib3==2.6.0
    # via requests

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.23)

project(zeem-examples LANGUAGES CXX)

# Only try to find package if we're not included from the main zeem CMakeLists.txt
get_property(PARENT_DIRECTORY DIRECTORY "${CMAKE_CURRENT_LIST_DIR}" PROPERTY PARENT_DIRECTORY)

if("${PARENT_DIRECTORY}" STREQUAL "")
	find_package(zeem REQUIRED)
endif()

list(APPEND examples zeem-synopsis zeem-serialize zeem-validating-xml zeem-xpath-sample clavichord-example)

foreach(EXAMPLE IN LISTS examples)
	add_executable(${EXAMPLE} ${EXAMPLE}.cpp)
	target_link_libraries(${EXAMPLE} zeem::zeem)
endforeach()

=== test/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause
# 
# Copyright (c) 2026 Maarten L. Hekkelman
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

CPMFindPackage(NAME Catch2 GIT_REPOSITORY "https://github.com/catchorg/Catch2" VERSION "3.4.0" EXCLUDE_FROM_ALL YES)
CPMFindPackage(NAME mcfp GIT_REPOSITORY "https://forge.hekkelman.net/maarten/mcfp.git" GIT_TAG v1.4.2 EXCLUDE_FROM_ALL YES)

# data files for the parser test
set(XML_CONF_TAR ${CMAKE_CURRENT_SOURCE_DIR}/XML-Test-Suite.tbz)
set(XML_CONF_FILE ${CMAKE_CURRENT_SOURCE_DIR}/XML-Test-Suite/xmlconf/xmlconf.xml)

if(NOT EXISTS ${XML_CONF_FILE})
	if(${CMAKE_VERSION} VERSION_LESS "3.18.0")
		find_program(TAR tar)

		if(TAR)
			add_custom_command(OUTPUT ${XML_CONF_FILE}
				COMMAND ${TAR} xf ${XML_CONF_TAR}
				WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/lib-xml/test/)
		else()
			message(FATAL_ERROR "Please extract the archive ${XML_CONF_TAR} manually or update your cmake version to at least 3.18")
		endif()
	else()
		file(ARCHIVE_EXTRACT INPUT ${XML_CONF_TAR}
			DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})
	endif()
endif()

add_custom_target(XML_CONF ALL DEPENDS ${XML_CONF_FILE})

# add_test(NAME unit-test-1
# COMMAND $<TARGET_FILE:unit-test-1> --data-dir ${CMAKE_CURRENT_SOURCE_DIR})
list(APPEND ZEEM_TESTS
	unit
	parser
	serializer
	xpath)

foreach(TEST IN LISTS ZEEM_TESTS)
	set(ZEEM_TEST "${TEST}-test")
	set(ZEEM_TEST_SOURCE "${CMAKE_CURRENT_SOURCE_DIR}/${ZEEM_TEST}.cpp")

	add_executable(${ZEEM_TEST} ${ZEEM_TEST_SOURCE})

	target_link_libraries(${ZEEM_TEST} PRIVATE mcfp::mcfp zeem::zeem Catch2::Catch2)

	if(MSVC)
		# Specify unwind semantics so that MSVC knowns how to handle exceptions
		target_compile_options(${ZEEM_TEST} PRIVATE /EHsc)
	endif()

	if("${TEST}" STREQUAL "parser")
		# Some tests should be skipped
		list(APPEND ZEEM_TEST_ARGS
			ibm-valid-P28-ibm28v02.xml ibm-valid-P29-ibm29v01.xml ibm-valid-P29-ibm29v02.xml
			ibm-1-1-valid-P03-ibm03v09.xml rmt-e2e-34 rmt-e2e-55 rmt-054 rmt-ns10-006 rmt-e3e-13)
		list(TRANSFORM ZEEM_TEST_ARGS PREPEND "--questionable=")
		list(PREPEND ZEEM_TEST_ARGS ${XML_CONF_FILE} "--print-ids")
		add_dependencies(${ZEEM_TEST} XML_CONF)
	else()
		set(ZEEM_TEST_ARGS "")
	endif()

	add_test(NAME ${ZEEM_TEST}
		COMMAND $<TARGET_FILE:${ZEEM_TEST}> ${ZEEM_TEST_ARGS}
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/)
endforeach()

=== debian/changelog ===
libzeem (2.1.2+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Exclude potentially copyrighted test files, skip running tests
  * Symlink jquery.js as provided by its Debian package.
  * Add myself to uploaders

 -- Andrius Merkys <merkys@debian.org>  Fri, 20 Feb 2026 03:25:44 -0500

libzeem (2.0.5-1) unstable; urgency=medium

  * Initial release. Closes: #1121715

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 03 Dec 2025 09:06:08 +0100

=== debian/control ===
Source: libzeem
Section: libs
Priority: optional
Maintainer: Maarten L. Hekkelman <maarten@hekkelman.com>
Uploaders:
 Andrius Merkys <merkys@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libmcfp-dev,
 libhowardhinnant-date-dev,
 catch2,
 doxygen,
 python3-exhale,
 python3-sphinx-rtd-theme,
 python3-myst-parser
Standards-Version: 4.7.2
Homepage: https://forge.hekkelman.net/maarten/zeem
Vcs-Git: https://salsa.debian.org/debian/libzeem.git
Vcs-Browser: https://salsa.debian.org/debian/libzeem

Package: libzeem-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libzeem2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests: libzeem-doc, mrc
Description: Development files for libzeem
 Libzeem is a complete XML library written in C++. It has a DOM
 interface, a validating parser, DTD support and an implementation
 of XPath 1.0. There is also support for serialization of objects
 using an approach similar to boost::serialization.
 .
 This specific package contains the files you need to develop software
 using libzeem.

Package: libzeem-doc
Section: doc
Architecture: all
Depends:
 libboost-regex-dev,
 zlib1g-dev,
 ${misc:Depends},
 libjs-sphinxdoc,
 libjs-jquery
Description: Documentation files for libzeem
 Libzeem is a complete XML library written in C++. It has a DOM
 interface, a validating parser, DTD support and an implementation
 of XPath 1.0. There is also support for serialization of objects
 using an approach similar to boost::serialization.
 .
 This specific package contains the documentation you can use to develop new
 software using libcifpp.

Package: libzeem2
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: Library file for libzeem
 Libzeem is a complete XML library written in C++. It has a DOM
 interface, a validating parser, DTD support and an implementation
 of XPath 1.0. There is also support for serialization of objects
 using an approach similar to boost::serialization.
 .
 This package contains the library file only.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
# Fixing reproducible builds
LC_ALL := C.UTF-8
export LC_ALL

%:
	dh $@

# Tests are turned off due to excluded test files
override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DZEEM_BUILD_DOCUMENTATION=ON \
		-DZEEM_BUILD_EXAMPLES=ON \
		-DBUILD_TESTING=OFF

execute_after_dh_auto_install:
	rm debian/tmp/usr/share/doc/zeem/_static/jquery.js

execute_after_dh_clean:
	rm -rf doc/html doc/mxml/.buildinfo docs/api

=== debian/tests/control ===
Tests: testcode.sh
Depends: build-essential, libzeem-dev, cmake, libhowardhinnant-date-dev
Restrictions: allow-stderr

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libzeem-$1\.tar\.gz/,repack,repacksuffix=+dfsg,dversionmangle=auto \
  https://github.com/mhekkel/zeem/tags .*/v?(\d\S*)\.tar\.gz
